/*
!=======================================================================
!
!  PROGRAM  PHASE-Viewer  (PHASE-Viewer 2014.01 ver.3.3.0)
!
!  Created on 2005/10/05, 19:17
!  AUTHOR(S): KOGA, Junichiro
!  File : StringIndexArray.java
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!   Since 2002, this program set had been intensively developed as a part of the following 
!  national projects supported by the Ministry of Education, Culture, Sports, Science and
!  Technology (MEXT) of Japan; "Frontier Simulation Software for Industrial Science
!  (FSIS)" from 2002 to 2005, "Revolutionary Simulation Software (RSS21)" from 2006 to
!  2008. "Research and Development of Innovative Simulation Software (RISS)" from 2008
!  to 2013. These projects is lead by the Center for Research on Innovative Simulation 
!  Software (CISS), the Institute of Industrial Science (IIS), the University of Tokyo.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium. 
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!=======================================================================
 */

package ciss.phase_viewer.common;

import java.util.Vector;

import org.apache.log4j.Logger;

/**
 * Stringを引数に使える「配列」
 * 
 * @author
 */
public class StringIndexArray {
    private Logger logger = Logger.getLogger(StringIndexArray.class.getName());

    private Object defaultValue;
    private Vector indeces;
    private Vector values;

    /**
     * Creates a new instance of StringIndexArray
     * 
     * @param defaultValue
     *            インデックスの文字列が見つからなかった場合のデフォルト値.
     */
    public StringIndexArray(Object defaultValue) {
        this.defaultValue = defaultValue;
        indeces = new Vector();
        values = new Vector();
    }

    /**
     * 要素をセット.
     * 
     * @param index
     *            インデックス用文字列. すでにない場合は新たに作られる.
     * @param val
     *            セットしたい要素.
     */
    public void set(String index, Object val) {
        for (int i = 0; i < indeces.size(); i++) {
            if (((String) indeces.elementAt(i)).equals(index)) {
                values.set(i, val);
                return;
            }
        }
        indeces.addElement(index);
        values.addElement(val);
    }

    /**
     * インデックスによって指定される要素を返す.
     * 
     * @param index
     *            インデックス用文字列
     * @return indexに関連付けられた値. 見つからない場合defaultValueを返す.
     */
    public Object get(String index) {
        for (int i = 0; i < indeces.size(); i++) {
            if (((String) indeces.elementAt(i)).equals(index)) {
                return values.elementAt(i);
            }
        }
        return defaultValue;
    }

}
